Subject: bug#67526: 30.0.50; Regression: gnus-group-prev-group fails to move to first group

From: Simon Leinen <[email-masked]>
Date: Wed, 29 Nov 2023 16:50:32 +0100

Dear Eric,

thanks for looking at this!

> I'm not able to reproduce this, with or without topic-mode. Is there
> anything special about the level of the first or the second group, and
> `gnus-level-subscribed'? I can't see anything else that might influence
> behavior here...

How do I find out whether anything is special about the level of those
groups? For me,

gnus-topic-mode is nil
gnus-level-subscribed is 5

The top three lines of my newsgroup list look like this:

     193: nnimap+mail.switch.ch:INBOX
      19: nnimap+mail.switch.ch:switch/network
      27: nnimap+mail.switch.ch:net/freertr

Reproducing the issue is as easy as typing "n" and then "p".  The cursor
will be stuck on the second line.  I can try narrowing this case, but
it's hard for me to get gnus working again from emacs -q :-)

I do note that the issue goes away when I revert a bit of your change,
as follows.  I haven't found out *why* that is necessary to get the old
behavior back...

diff --git a/lisp/gnus/gnus-group.el b/lisp/gnus/gnus-group.el
index 9a1a6f9b27d..2f81ea96210 100644
--- a/lisp/gnus/gnus-group.el
+++ b/lisp/gnus/gnus-group.el
@@ -1758,7 +1758,7 @@ gnus-group-search-forward
     (unless first-too
       (forward-line way))
     (while (and
-	    (not (if backward (bobp) (eobp)))
+	    (not (endp))
 	    (not (setq
 		  found
 		  (and